C --- EMIN.FTN ---
C ------------------------------------------------------------
      INTEGER     IERR,MDOC,M
      CHARACTER   LINE*256
      CHARACTER   NAMEC*80,NAMER*80,NAMEV*80,NAMET*80
      CHARACTER   NAMEO*80,NAMEG*80,NAMEI*80,NAMES*80
      CHARACTER   MSG*1,REF*1,LIST*1
      CHARACTER   PROG_LIB_PATH*80,PROG_NAME*80 
      CHARACTER   LIBS_PATH*80,LIBS_NAME*80,LIBS_EXT*80 
C ---
      INCLUDE 'emin_version.fh'
C==================================================================
      M    = 0
      IERR = 0
C     CALL GET_PATH(M,'MAKECIF',LINE,IERR)
      CALL GET_PATH(M,'CLIBD_MON',LINE,IERR)
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0.AND.IERR.EQ.0) THEN
C       PROG_LIB_PATH = LINE(1:LEN)//'/dic/'
        PROG_LIB_PATH = LINE(1:LEN)
      ELSE
        CALL GET_PATH(M,'MAKECIF',LINE,IERR)
        IF(LEN.GT.0.AND.IERR.EQ.0) THEN
          PROG_LIB_PATH = LINE(1:LEN)//'/dic/'
        ELSE
          PROG_LIB_PATH = ' '
        ENDIF
      ENDIF
C ---------------------------
      LIBS_PATH = ' '
      LIBS_NAME = ' '
      LIBS_EXT  = ' ' 
      PROG_NAME = 'emin'
      CALL SET_PATH_PROG_PARM(PROG_LIB_PATH,PROG_NAME
     *                         ,LIBS_PATH,LIBS_NAME,LIBS_EXT)
C ===========================
      M    = 0
      IG   = 0
      CALL START_CCP4
      CALL START(IG,M,PROG_NAME)
C ---------------------------
      CALL MSGDOC(M,' ')
      CALL MSGDOC(M,VERSION)
      CALL MSGDOC(M,' ')
C -------------------------------------------------------------
      CALL MSGDOC(M,
     *' Do you want to have FILE-DOCUMENT /emin.doc/ ? /<N>/Y/A :')
      CALL MSGDOC(M,'   N - means without DOC-file')
      CALL MSGDOC(M,'   Y - with new contents')
      CALL MSGDOC(M,
     *'   A - means to keep old contents and add new information')
      CALL MSGDOC(M,
     *'       with DOC-file program creates batch file: emin.bat')
      CALL DISPL_BL('_DOC:')
      READ(*,'(A)') LINE

      IBATCH = 0
      IF(LINE(1:4).EQ.'_DOC') THEN
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.6) THEN
          DO I=6,LEN
            IF(LINE(I:I).NE.' ') THEN
              MSG=LINE(I:I)
              GO TO 10
            ENDIF
          ENDDO
        ENDIF
  10    CONTINUE
        IBATCH = 1
      ELSE
        MSG=LINE(1:1)
      ENDIF

      IF(MSG.EQ.'y') MSG = 'Y'
      IF(MSG.EQ.'a') MSG = 'A'
      IF(MSG.NE.'Y'.AND.MSG.NE.'A'.AND.MSG.NE.'#') MSG = 'N'

      IF(MSG.NE.'N'.OR.MSG.EQ.'#') THEN
        IF(MSG.EQ.'Y') MDOC = 999
        IF(MSG.EQ.'A') MDOC = 998
        IF(MSG.EQ.'#') MDOC = 997
        CALL START(IG,MDOC,PROG_NAME)
      ELSE
        MDOC=0
      ENDIF
      IF(IBATCH.EQ.1) CALL SET_BATCH(IBATCH)
C -------------------------------------------------------------
 100  IERR = 0
      CALL CHECK_BATCH(IBAT)
      IF(IBAT.LE.0) CALL SET_DEFAULT('   input-coord-file')
      LINE='FILE_C'
      CALL ASK(LINE)
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.1.OR.LINE(1:1).EQ.','.OR.LINE(1:1).EQ.' ') THEN
        CALL MSGDOC(M,' ERROR: wrong name of input file')
        GO TO 100
      ENDIF
      NAMEC = LINE(1:LEN)
      IF(LEN.GE.1) THEN
        DO I=LEN,1,-1
          IF(LINE(I:I).EQ.',') THEN
            LINE(I:I)=' '
          ELSE
            IF(LINE(I:I).NE.' ') GO TO 110
          ENDIF 
        ENDDO
 110    CONTINUE
      ENDIF
      CALL LENSTR_BL(LINE,LEN)
      NAMEC=LINE(1:LEN)
C -------------------------------------------
 200  IERR = 0
      CALL CHECK_BATCH(IBAT)
      IF(IBAT.LE.0) CALL SET_DEFAULT('   input-restraint-file')
      LINE='FILE_R'
      CALL ASK(LINE)
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.1.OR.LINE(1:1).EQ.','.OR.LINE(1:1).EQ.' ') THEN
        CALL MSGDOC(M,' ERROR: wrong name of input file')
        GO TO 200
      ENDIF
      NAMER = LINE(1:LEN)
      IF(LEN.GE.1) THEN
        DO I=LEN,1,-1
          IF(LINE(I:I).EQ.',') THEN
            LINE(I:I)=' '
          ELSE
            IF(LINE(I:I).NE.' ') GO TO 210
          ENDIF 
        ENDDO
 210    CONTINUE
      ENDIF
      CALL LENSTR_BL(LINE,LEN)
      NAMER=LINE(1:LEN)
C -------------------------------------------
      NCYCLE = 0
      SLIM   = 0.0
      RESOL  = 0.0
      ITEST  = 0
      CALL MSGDOC(M,' ')
      CALL MSGDOC(M,'#')
      CALL MSGDOC(M,'#     Keywords:')
      CALL MSGDOC(M,'#')
      CALL SET_DEFAULT(
     *'FILE_V:  < >  - input file /VDW_restraints/ , " " means without t
     *his file')
      CALL SET_DEFAULT(
     *'FILE_T:  < >  - input CIfile /target/')
      CALL SET_DEFAULT(
     *'FILE_O:  < >  - output CIfile /crd/, default: emin.crd ')
      CALL SET_DEFAULT(
     *'FILE_G:  < >  - output file of gradients, default: emin_grd.crd
     *')
      CALL SET_DEFAULT (
     *'FILE_I:  < >  - output file of inform. about gradients
     *')
      CALL SET_DEFAULT(
     *'                default: emin_ind.crd')
      CALL SET_DEFAULT(
     *'NC:     <10>  - max number of function calculation')
      CALL SET_DEFAULT(
     *'REF:    <E>/T - E_energy minimization , Thermal factor regulariza
     *tion')
C      CALL SET_DEFAULT(
C     *'RESOL:   <1.0> - resolution / for REF = "T" / ')
      CALL SET_DEFAULT(
     *'SLIM:   <0.0> - level of messages. if abs(Videal-Vobs)/SIG > SLIM
     *, write')
      CALL SET_DEFAULT(
     *'                information to DOC_file')
      CALL SET_DEFAULT(
     *'CUT:     <0>  - distance cut_off, 0 - means without VDW and H-bon
     *ds')
      CALL SET_DEFAULT(
     *'TEST:    <0>  - 1-only Bond, 2-only Angle, 3-only B&A, 4-only V&H
     *')
      CALL SET_DEFAULT(
     *'                 5-only tors, 6-only chir, 7-only plan')
      CALL SET_DEFAULT(
     *'LIST: <S>/L  - S short output, L - long')
C ---
      CALL MSGDOC(M,' ')
      CALL SET_DEFAULT('?')
C -------------------------------------------
      LINE='SLIM'
      CALL ASK(LINE)
      READ(LINE,*) SLIM
C ---
      LINE='RESOL'
      CALL ASK(LINE)
      READ(LINE,*) RESOL
C ---
      LINE='REF'
      CALL ASK(LINE)
      REF=LINE(1:1)  
C ---  
      LINE='FILE_V'
      CALL ASK(LINE)
      NAMEV=LINE
      CALL CORR_FILE_NAME(NAMEV)
C ---
      LINE='FILE_O'
      CALL ASK(LINE)
      NAMEO=LINE
      CALL CORR_FILE_NAME(NAMEO)
C ---
      LINE='FILE_I'
      CALL ASK(LINE)
      NAMEI=LINE
      CALL CORR_FILE_NAME(NAMEI)
C ---
      LINE='FILE_T'
      CALL ASK(LINE)
      NAMET=LINE
      CALL CORR_FILE_NAME(NAMET)
C ---
      LINE='FILE_G'
      CALL ASK(LINE)
      NAMEG=LINE
      CALL CORR_FILE_NAME(NAMEG)
C ---
      LINE='NC'
      CALL ASK(LINE)
      READ(LINE,*) NCYCLE
C ---
      LINE='TEST'
      CALL ASK(LINE)
      READ(LINE,*) ITEST
C ---
      LINE='LIST'
      CALL ASK(LINE)
      LIST=LINE(1:1)  
C ---
      LIBS_PATH = ' '
      LIBS_NAME = ' '
      LIBS_EXT  = ' ' 
C --------------------------------------
      NAMES = ' '
      CALL EMIN(MDOC,NAMEC,NAMER,NAMEV,NAMES,NAMET
     * ,NAMEO,NAMEG,NAMEI,NCYCLE,SLIM,REF,RESOL
     * ,PROG_LIB_PATH,LIBS_PATH,LIBS_NAME,LIBS_EXT,PROG_NAME
     * ,ITEST,LIST,IERR)
C --------------------------------------
      CALL FINISH
      END
