C ******
C -P-
C -P------   SUBROUTINES DEPENDED ON SYSTEM --------------------
C -P-
C      CVX - for VMS VAX 
C      CDP - for unix system
C      CMS - for MS-DOS
C      CLN - for Linux 
C ******

      SUBROUTINE GET_PATH(MDOC,NAME,PATH,IERR)
C ----------------------------------------
C
C -P- GET_PATH - call getenv / get BLANC - path of blanc directory /
C
      CHARACTER NAME*(*),PATH*(*)
C ******
C ----------------------------------------
C     / setenv BLANC ~alexei/blanc /
C     CALL GET_PATH('BLANC',LINE)
C     LINE='~alexei/blanc' 
C ----------------------------------------
      CHARACTER LINE*256
  
      INCLUDE "temp_makecif_path.fh"
C ------------------------------------
      IERR=0

      CALL GETENV(NAME,LINE)
      CALL LENSTR_BL(LINE,LEN)
cd
C      call getenv('CLIBD_MON',LINE)
C      call lenstr_bl(line,len)
cd      LEN = 0
      IF(LEN.LE.0) THEN
        PATH=MAKECIFLIB
      ELSE
        PATH=LINE(1:LEN)
      ENDIF

      RETURN
      END

C ******
      SUBROUTINE DISPL_BL(LINE)
C
C -P- DISPL_BL - write message to terminal and stop cursor at the end of line.
C
C             NOTE : for Linux ( CLN ) cursor will not stop
C                    at the end of line.
C
      CHARACTER LINE*(*)
      INTEGER*4 NL
C ----------------------------
      CALL LENSTR_BL(LINE,NL)
      IF(NL.GT.79) NL=79

CVX   WRITE(*,'(''$'',A)')   LINE(1:NL)
      WRITE(*,'('' '',A,$)') LINE(1:NL)
CMS   WRITE(*,'('' '',A,\)') LINE(1:NL)
CLN   WRITE(*,'('' '',A)')   LINE(1:NL)
      RETURN
      END
C ******

C ******
      SUBROUTINE CLOCK(IH)
C
C -P- CLOCK - get date to --> array IH()
C
C    IH(2),IH(3),IH(4),    IH(5),IH(6),IH(7)
C     sec   min  hour      day   month year
C
      INTEGER*4 IH(7)
      CHARACTER  cdate*8,ctime*10,czone*5
      INTEGER    ivalues(8)
C ******
CMS   INTEGER*2 IHR,IMN,ISEC,I100H,IYR,IMON,IDAY
CVX   CHARACTER STR*8
      INTEGER*4 ID(3)
CLN   INTEGER*4 ID(3)
c --------------------------------
CVX   CALL IDATE(I1,I2,I3)
CVX   IH(5)=I2
CVX   IH(6)=I1
CVX   IT1  =I3+1900
CVX   IH(7)=IT
CVX   CALL TIME(STR)
CVX   READ(STR,'(I2,1X,I2,1X,I2)') IH(4),IH(3),IH(2)
CVX   IH(1)=0
C
CMS   CALL GETTIM(IHR,IMN,ISEC,I100H)
CMS   CALL GETDAT(IYR,IMON,IDAY)
CMS   IH(4)=IHR
CMS   IH(3)=IMN
CMS   IH(2)=ISEC
CMS   IH(5)=IDAY
CMS   IH(6)=IMON
CMS   IH(7)=IYR
CMS   IH(1)=I100H/2

CDP
      ID(1) = 0
      ID(2) = 0
      ID(3) = 0
c      CALL ITIME(ID)
      IH(4)=ID(1)
      IH(3)=ID(2)
      IH(2)=ID(3)
      IDAY = 1
      IMON = 1
      IYR  = 0
c      CALL IDATE(IMON,IDAY,IYR)
      IF(IYR.GE.99) THEN
        IYR=IYR+1900
      ELSE
        IYR=IYR+2000
      ENDIF
      IH(5)=IDAY
      IH(6)=IMON
      IH(7)=IYR
      IH(1)=0
CDP 
c ===============================================
      CALL Date_and_Time(CDATE,CTIME,CZONE,IVALUES)
      IH(4)=IVALUES(5)
      IH(3)=IVALUES(6)
      IH(2)=IVALUES(7)
      IH(5)=IVALUES(3)
      IH(6)=IVALUES(2)
      IH(7)=IVALUES(1)
      IH(1)=0
c ================================================
c
C  Dummy routine for Linux
C
CLN   IH(4)=0
CLN   IH(3)=0
CLN   IH(2)=0
CLN   IH(5)=01
CLN   IH(6)=01
CLN   IH(7)=1990
CLN   IH(1)=0

      RETURN
      END

C ===============================================================

      SUBROUTINE GETNOS(CH3)
C
C -P- GETNOS - get name of operating system
C
      CHARACTER CH3*3
C --------------------------------
CMS   CH3='MSD'      
CVX   CH3='VAX'      
      CH3='UNX'      
CLN   CH3='LIN'      
      RETURN
      END

CMS   SUBROUTINE EXIT
CMS   STOP
CMS   END

