C --- MODCHECK.FTN ---
C ------------------------------------------------------------
      INTEGER   IERR,MDOC,M
      CHARACTER LINE*80
      CHARACTER NAMEC*80,NAMEO*80,NAMEP*80,MSG*1
      CHARACTER NAMER*80,NAMEV*80
      CHARACTER PROG_LIB_PATH*80,PROG_NAME*8 
      CHARACTER LIBS_PATH*80,LIBS_NAME*80,LIBS_EXT*80 
      CHARACTER HFLAG*1,SEG_FLAG*1
C ---
      INCLUDE 'modcheck_version.fh'
C==================================================================
      M    = 0
      IERR = 0
C     CALL GET_PATH(M,'MAKECIF',LINE,IERR)
      CALL GET_PATH(M,'CLIBD_MON',LINE,IERR)
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.GT.0.AND.IERR.EQ.0) THEN
C       PROG_LIB_PATH = LINE(1:LEN)//'/dic/'
        PROG_LIB_PATH = LINE(1:LEN)
      ELSE
        CALL GET_PATH(M,'MAKECIF',LINE,IERR)
        IF(LEN.GT.0.AND.IERR.EQ.0) THEN
          PROG_LIB_PATH = LINE(1:LEN)//'/dic/'
        ELSE
          PROG_LIB_PATH = ' '
        ENDIF
      ENDIF
C --------------------------
      LIBS_PATH = ' '
      LIBS_NAME = ' '
      LIBS_EXT  = ' ' 
      PROG_NAME = 'modcheck'
      CALL SET_PATH_PROG_PARM(PROG_LIB_PATH,PROG_NAME
     *                         ,LIBS_PATH,LIBS_NAME,LIBS_EXT)
C ===========================
      M    = 0
      IG   = 0
      CALL START_CCP4
C      PROG = 'modcheck'
      CALL START(IG,M,PROG_NAME)
C ---------------------------
      CALL MSGDOC(M,' ')
      CALL MSGDOC(M,VERSION)
      CALL MSGDOC(M,' ')
C -------------------------------------------------------------
      CALL MSGDOC(M,
     *' Do you want to have FILE-DOCUMENT /modcheck.doc/ ? /<N>/Y/A :')
      CALL MSGDOC(M,'   N - means without DOC-file')
      CALL MSGDOC(M,'   Y - with new contents')
      CALL MSGDOC(M,
     *'   A - means to keep old contents and add new information')
      CALL MSGDOC(M,
     *'       with DOC-file program creates batch file: modcheck.bat')
      CALL DISPL_BL('_DOC:')
      READ(*,'(A)') LINE

      IBATCH = 0
      IF(LINE(1:4).EQ.'_DOC') THEN
        CALL LENSTR_BL(LINE,LEN)
        IF(LEN.GE.6) THEN
          DO I=6,LEN
            IF(LINE(I:I).NE.' ') THEN
              MSG=LINE(I:I)
              GO TO 10
            ENDIF
          ENDDO
        ENDIF
  10    CONTINUE
        IBATCH = 1
      ELSE
        MSG=LINE(1:1)
      ENDIF

      IF(MSG.EQ.'y') MSG = 'Y'
      IF(MSG.EQ.'a') MSG = 'A'
      IF(MSG.NE.'Y'.AND.MSG.NE.'A'.AND.MSG.NE.'#') MSG = 'N'

      IF(MSG.NE.'N'.OR.MSG.EQ.'#') THEN
        IF(MSG.EQ.'Y') MDOC = 999
        IF(MSG.EQ.'A') MDOC = 998
        IF(MSG.EQ.'#') MDOC = 997
        CALL START(IG,MDOC,PROG_NAME)
      ELSE
        MDOC=0
      ENDIF
      IF(IBATCH.EQ.1) CALL SET_BATCH(IBATCH)
C -------------------------------------------------------------
 100  IERR = 0
      CALL CHECK_BATCH(IBAT)
      IF(IBAT.LE.0) CALL SET_DEFAULT('   input-coord-file')
      LINE='FILE_C'
      CALL ASK(LINE)
      CALL LENSTR_BL(LINE,LEN)
      IF(LEN.LT.1.OR.LINE(1:1).EQ.','.OR.LINE(1:1).EQ.' ') THEN
        CALL MSGDOC(M,' ERROR: wrong name of input file')
        GO TO 100
      ENDIF
      NAMEC = LINE(1:LEN)
      CALL CORR_FILE_NAME(NAMEC)

c 200  IERR = 0
c      CALL CHECK_BATCH(IBAT)
c      IF(IBAT.LE.0) CALL SET_DEFAULT('   input-restraint-file')
c      LINE='FILE_R'
c      CALL ASK(LINE)
c      CALL LENSTR_BL(LINE,LEN)
c      IF(LEN.LT.1.OR.LINE(1:1).EQ.','.OR.LINE(1:1).EQ.' ') THEN
c        CALL MSGDOC(M,' ERROR: wrong name of input file')
c        GO TO 200
c      ENDIF
c      NAMER = LINE(1:LEN)
C -------------------------------------------
      SLIM=0.0
      CALL MSGDOC(M,' ')
      CALL MSGDOC(M,'#')
      CALL MSGDOC(M,'#     Keywords:')
      CALL MSGDOC(M,'#')
      CALL SET_DEFAULT(
     *'SLIM:  <0.0> - level of messages. if abs(Videal-Vobs)/SIG > SLIM,
     *')
      CALL SET_DEFAULT(
     *'               the information about restraints will be written t
     *o DOC_file')
      CALL SET_DEFAULT(
     *'FILE_R: < >  - intput file RST_restraints, " " means without this 
     * file')
      CALL SET_DEFAULT(
     *'FILE_V: < >  - intput file VDW_restraints, " " means without this 
     * file')
      CALL SET_DEFAULT(
     *'FILE_O: < >  - output CIfile /crd/  , " " means without this file
     *')
      CALL SET_DEFAULT(
     *'FILE_P: < >  - output PDB_file /pdb/, " " means without this file
     *')
      CALL SET_DEFAULT(
     *'HFLAG: <N>,Y - Y write H-atoms to output PDB_file')
      CALL SET_DEFAULT(
     *'SEG: <N>/Y   - Y - write SEG_ID instead CHAIN_ID to output PDB_fi
     *le')
      CALL MSGDOC(M,' ')
      CALL SET_DEFAULT('?')
C -------------------------------------------
      LINE='SLIM'
      CALL ASK(LINE)
      READ(LINE,*) SLIM
C ---
      LINE='HFLAG'
      CALL ASK(LINE)
      HFLAG = LINE(1:1)
C ---
      LINE='SEG'
      CALL ASK(LINE)
      SEG_FLAG=LINE(1:1)
C ---
      LINE='FILE_O'
      CALL ASK(LINE)
      NAMEO=LINE
      CALL CORR_FILE_NAME(NAMEO)
C ---
      LINE='FILE_V'
      CALL ASK(LINE)
      NAMEV=LINE
      CALL CORR_FILE_NAME(NAMEV)
C ---
      LINE='FILE_R'
      CALL ASK(LINE)
      NAMER=LINE
      CALL CORR_FILE_NAME(NAMER)
C ---
      LINE='FILE_P'
      CALL ASK(LINE)
      NAMEP=LINE
      CALL CORR_FILE_NAME(NAMEP)
C ---
      LIBS_PATH = ' '
      LIBS_NAME = ' '
      LIBS_EXT  = ' ' 
C --------------------------------------
      CALL MODCHECK(MDOC,NAMEC,NAMER,NAMEV,NAMEO,NAMEP,SLIM
     * ,HFLAG,SEG_FLAG
     * ,PROG_LIB_PATH,LIBS_PATH,LIBS_NAME,LIBS_EXT,PROG_NAME,IERR)
C --------------------------------------
      CALL FINISH
      END
